#!/usr/bin/perl

## --> Line-of-Sight Path Analysis, linesite.cgi
## --> Green Bay Professional Packet Radio, www.gbppr.org

## This file Copyright 2003 <contact@gbppr.org> under the GPL.
## NO WARRANTY.  Please send bug reports / patches.

# Setup
#
$ENV{PATH} = "/bin:/usr/bin:/usr/local/bin";
select STDOUT;
$| = 1;
use Math::Trig;
require "flush.pl";
$DEBUG = 1;

# Print MIME
#
print "Content-type:text/html\n\n";
&flush(STDOUT);

# Read environment
#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}

my $LAT1_D = $FORM{'LAT1_D'};
my $LAT1_M = $FORM{'LAT1_M'};
my $LAT1_S = $FORM{'LAT1_S'};

my $LON1_D = $FORM{'LON1_D'};
my $LON1_M = $FORM{'LON1_M'};
my $LON1_S = $FORM{'LON1_S'};

my $LAT2_D = $FORM{'LAT2_D'};
my $LAT2_M = $FORM{'LAT2_M'};
my $LAT2_S = $FORM{'LAT2_S'};

my $LON2_D = $FORM{'LON2_D'};
my $LON2_M = $FORM{'LON2_M'};
my $LON2_S = $FORM{'LON2_S'};

my $LAT3_D = $FORM{'LAT3_D'};
my $LAT3_M = $FORM{'LAT3_M'};
my $LAT3_S = $FORM{'LAT3_S'};

my $LON3_D = $FORM{'LON3_D'};
my $LON3_M = $FORM{'LON3_M'};
my $LON3_S = $FORM{'LON3_S'};

my $LAT4_D = $FORM{'LAT4_D'};
my $LAT4_M = $FORM{'LAT4_M'};
my $LAT4_S = $FORM{'LAT4_S'};

my $LON4_D = $FORM{'LON4_D'};
my $LON4_M = $FORM{'LON4_M'};
my $LON4_S = $FORM{'LON4_S'};

my $tx_ant_ht_val = $FORM{'tx_ant_ht_val'};
my $tx_ant_ht = $FORM{'tx_ant_ht'};

my $tx2_ant_ht_val = $FORM{'tx2_ant_ht_val'};
my $tx2_ant_ht = $FORM{'tx2_ant_ht'};

my $tx3_ant_ht_val = $FORM{'tx3_ant_ht_val'};
my $tx3_ant_ht = $FORM{'tx3_ant_ht'};

my $tx4_ant_ht_val = $FORM{'tx4_ant_ht_val'};
my $tx4_ant_ht = $FORM{'tx4_ant_ht'};

my $k = $FORM{'k'};

my $rx_ant_ht_val = $FORM{'rx_ant_ht_val'};
my $rx_ant_ht = $FORM{'rx_ant_ht'};

my $state = $FORM{'state'};

my $coverage = $FORM{'coverage'};
my $coverage_val = $FORM{'coverage_val'};

my $quality = $FORM{'quality'};

# Begin
#
($sec,$min,$hour,$mday,$mon,$year) = gmtime;
$hour = sprintf "%02.0f",$hour;
$min  = sprintf "%02.0f",$min;
$sec  = sprintf "%02.0f",$sec;
$mon  = sprintf "%02.0f",($mon+1);
$mday = sprintf "%02.0f",$mday;
$year = sprintf "%02.0f",$year;
$year = 1900 + $year;

$RAN = sprintf "%.f", rand(10000000);
mkdir "tmp/$mon-$mday";
mkdir "tmp/$mon-$mday/$RAN";
chdir "tmp/$mon-$mday/$RAN";
unlink <*>;
symlink "/usr/splat/sdf", "sdf";

sub System {
if ((0xffff & system $args) != 0 ) {
  print STDERR "error: $!\n";
  exit 1;
 }
}

$LAT1_D =~ tr/0-9.//csd;
$LAT1_M =~ tr/0-9.//csd;
$LAT1_S =~ tr/0-9.//csd;

$LON1_D =~ tr/0-9.//csd;
$LON1_M =~ tr/0-9.//csd;
$LON1_S =~ tr/0-9.//csd;

if ($LAT1_D > 72 || $LAT1_D < 17) {
  print "<b>BAD COORDINATES! - $LAT1_D &gt; 72 or $LAT1_D &lt; 17</b>\n";
  exit 1;
}
if ($LAT1_M > 60) {
  print "<b>BAD COORDINATES! - $LAT1_M &gt; 60</b>\n";
  exit 1;
}
if ($LAT1_S > 60) {
  print "<b>BAD COORDINATES! - $LAT1_S &gt; 60</b>\n"; 
  exit 1;
}

if ($LON1_D > 180) {
  print "<b>BAD COORDINATES! - $LON1_D &gt; 180</b>\n";
  exit 1;
}
if ($LON1_M > 60) {
  print "<b>BAD COORDINATES! - $LON1_M &gt; 60</b>\n"; 
  exit 1;
}
if ($LON1_S > 60) {
  print "<b>BAD COORDINATES! - $LON1_S &gt; 60</b>\n"; 
  exit 1;
}

$LAT2_D =~ tr/0-9.//csd;
$LAT2_M =~ tr/0-9.//csd;
$LAT2_S =~ tr/0-9.//csd;

$LON2_D =~ tr/0-9.//csd;
$LON2_M =~ tr/0-9.//csd;
$LON2_S =~ tr/0-9.//csd;

if ($LAT2_D > 90) {
  print "<b>BAD COORDINATES! - $LAT2_D &gt; 90</b>\n";
  exit 1;
}
if ($LAT2_M > 60) {
  print "<b>BAD COORDINATES! - $LAT2_M &gt; 60</b>\n";
  exit 1;
}
if ($LAT2_S > 60) {
  print "<b>BAD COORDINATES! - $LAT2_S &gt; 60</b>\n";
  exit 1;
}

if ($LON2_D > 180) {
  print "<b>BAD COORDINATES! - $LON2_D &gt; 180</b>\n";
  exit 1;
}
if ($LON2_M > 60) {
  print "<b>BAD COORDINATES! - $LON2_M &gt; 60</b>\n";
  exit 1;
}
if ($LON2_S > 60) {
  print "<b>BAD COORDINATES! - $LON2_S &gt; 60</b>\n";
  exit 1;
}

$LAT3_D =~ tr/0-9.//csd;
$LAT3_M =~ tr/0-9.//csd;
$LAT3_S =~ tr/0-9.//csd;

$LON3_D =~ tr/0-9.//csd;
$LON3_M =~ tr/0-9.//csd;
$LON3_S =~ tr/0-9.//csd;

if ($LAT3_D > 90) {
  print "<b>BAD COORDINATES! - $LAT3_D &gt; 90</b>\n";
  exit 1;
}
if ($LAT3_M > 60) {
  print "<b>BAD COORDINATES! - $LAT3_M &gt; 60</b>\n";
  exit 1;
}
if ($LAT3_S > 60) {
  print "<b>BAD COORDINATES! - $LAT3_S &gt; 60</b>\n";
  exit 1;
}

if ($LON3_D > 180) {
  print "<b>BAD COORDINATES! - $LON3_D &gt; 180</b>\n";
  exit 1;
}
if ($LON3_M > 60) {
  print "<b>BAD COORDINATES! - $LON3_M &gt; 60</b>\n";
  exit 1;
}
if ($LON3_S > 60) {
  print "<b>BAD COORDINATES! - $LON3_S &gt; 60</b>\n";
  exit 1;
}

$LAT4_D =~ tr/0-9.//csd;
$LAT4_M =~ tr/0-9.//csd;
$LAT4_S =~ tr/0-9.//csd;

$LON4_D =~ tr/0-9.//csd;
$LON4_M =~ tr/0-9.//csd;
$LON4_S =~ tr/0-9.//csd;

if ($LAT4_D > 90) {
  print "<b>BAD COORDINATES! - $LAT4_D &gt; 90</b>\n";
  exit 1;
}
if ($LAT4_M > 60) {
  print "<b>BAD COORDINATES! - $LAT4_M &gt; 60</b>\n";
  exit 1;
}
if ($LAT4_S > 60) {
  print "<b>BAD COORDINATES! - $LAT4_S &gt; 60</b>\n";
  exit 1;
}

if ($LON4_D > 180) {
  print "<b>BAD COORDINATES! - $LON4_D &gt; 180</b>\n";
  exit 1;
}
if ($LON4_M > 60) {
  print "<b>BAD COORDINATES! - $LON4_M &gt; 60</b>\n";
  exit 1;
}
if ($LON4_S > 60) {
  print "<b>BAD COORDINATES! - $LON4_S &gt; 60</b>\n";
  exit 1;
}

$LAT1 = sprintf "%.6f", $LAT1_D + ($LAT1_M / 60) + ($LAT1_S / 3600);
$LON1 = sprintf "%.6f", $LON1_D + ($LON1_M / 60) + ($LON1_S / 3600);

$LAT2 = sprintf "%.6f", $LAT2_D + ($LAT2_M / 60) + ($LAT2_S / 3600);
$LON2 = sprintf "%.6f", $LON2_D + ($LON2_M / 60) + ($LON2_S / 3600);

$LAT3 = sprintf "%.6f", $LAT3_D + ($LAT3_M / 60) + ($LAT3_S / 3600);
$LON3 = sprintf "%.6f", $LON3_D + ($LON3_M / 60) + ($LON3_S / 3600);

$LAT4 = sprintf "%.6f", $LAT4_D + ($LAT4_M / 60) + ($LAT4_S / 3600);
$LON4 = sprintf "%.6f", $LON4_D + ($LON4_M / 60) + ($LON4_S / 3600);

$LAT1_D = sprintf "%02.0f", $LAT1_D;
$LAT1_M = sprintf "%02.0f", $LAT1_M;
$LAT1_S = sprintf "%02.2f", $LAT1_S;

$LON1_D = sprintf "%03.0f", $LON1_D;
$LON1_M = sprintf "%02.0f", $LON1_M;
$LON1_S = sprintf "%02.2f", $LON1_S;

$LAT2_D = sprintf "%02.0f", $LAT2_D;
$LAT2_M = sprintf "%02.0f", $LAT2_M;
$LAT2_S = sprintf "%02.2f", $LAT2_S;

$LON2_D = sprintf "%03.0f", $LON2_D;
$LON2_M = sprintf "%02.0f", $LON2_M;
$LON2_S = sprintf "%02.2f", $LON2_S;

$LAT3_D = sprintf "%02.0f", $LAT3_D;
$LAT3_M = sprintf "%02.0f", $LAT3_M;
$LAT3_S = sprintf "%02.2f", $LAT3_S;

$LON3_D = sprintf "%03.0f", $LON3_D;
$LON3_M = sprintf "%02.0f", $LON3_M;
$LON3_S = sprintf "%02.2f", $LON3_S;

$LAT4_D = sprintf "%02.0f", $LAT4_D;
$LAT4_M = sprintf "%02.0f", $LAT4_M;
$LAT4_S = sprintf "%02.2f", $LAT4_S;

$LON4_D = sprintf "%03.0f", $LON4_D;
$LON4_M = sprintf "%02.0f", $LON4_M;
$LON4_S = sprintf "%02.2f", $LON4_S;

$rx_ant_ht =~ tr/0-9.//csd;

$tx_ant_ht =~ tr/0-9.//csd;

$tx2_ant_ht =~ tr/0-9.//csd;

$tx3_ant_ht =~ tr/0-9.//csd;

$tx4_ant_ht =~ tr/0-9.//csd;

if ($rx_ant_ht_val eq "feet") {
  $rx_ant_ht_m = sprintf "%.1f", $rx_ant_ht * 0.3048; # feet to meters
  $rx_ant_ht_ft = sprintf "%.1f", $rx_ant_ht; 
} 
else {
  $rx_ant_ht_m = sprintf "%.1f", $rx_ant_ht;
  $rx_ant_ht_ft = sprintf "%.1f", $rx_ant_ht / 0.3048;
} 

if ($tx_ant_ht_val eq "feet") {
  $tx_ant_ht_m = sprintf "%.1f", $tx_ant_ht * 0.3048; # feet to meters
  $tx_ant_ht_ft = sprintf "%.1f", $tx_ant_ht;
}
else {
  $tx_ant_ht_m = sprintf "%.1f", $tx_ant_ht;
  $tx_ant_ht_ft = sprintf "%.1f", $tx_ant_ht / 0.3048;
}

if ($tx2_ant_ht_val eq "feet") {
  $tx2_ant_ht_m = sprintf "%.1f", $tx2_ant_ht * 0.3048; # feet to meters
  $tx2_ant_ht_ft = sprintf "%.1f", $tx2_ant_ht; 
} 
else {
  $tx2_ant_ht_m = sprintf "%.1f", $tx2_ant_ht;
  $tx2_ant_ht_ft = sprintf "%.1f", $tx2_ant_ht / 0.3048;
} 

if ($tx3_ant_ht_val eq "feet") {
  $tx3_ant_ht_m = sprintf "%.1f", $tx3_ant_ht * 0.3048; # feet to meters
  $tx3_ant_ht_ft = sprintf "%.1f", $tx3_ant_ht; 
} 
else {
  $tx3_ant_ht_m = sprintf "%.1f", $tx3_ant_ht;
  $tx3_ant_ht_ft = sprintf "%.1f", $tx3_ant_ht / 0.3048;
} 

if ($tx4_ant_ht_val eq "feet") {
  $tx4_ant_ht_m = sprintf "%.1f", $tx4_ant_ht * 0.3048; # feet to meters
  $tx4_ant_ht_ft = sprintf "%.1f", $tx4_ant_ht; 
} 
else {
  $tx4_ant_ht_m = sprintf "%.1f", $tx4_ant_ht;
  $tx4_ant_ht_ft = sprintf "%.1f", $tx4_ant_ht / 0.3048;
} 

## Get K Factor
#
if ($k eq "5/12") {
  $k = 5 / 12;
  $k_str = "5/12";
}
elsif ($k eq "1/2") {
  $k = 1 / 2;
  $k_str = "1/2";
}
elsif ($k eq "2/3") {
  $k = 2 / 3;
  $k_str = "2/3";
}
elsif ($k eq "1.0") {
  $k = 1.0;
  $k_str = "1.0";
}
elsif ($k eq "7/6") {
  $k = 7 / 6;
  $k_str = "7/6";
}
elsif ($k eq "4/3") {
  $k = 4 / 3;
  $k_str = "4/3";
}
elsif ($k eq "5/3") {
  $k = 5 / 3;
  $k_str = "5/3";
}
elsif ($k eq "7/4") {
  $k = 7 / 4;
  $k_str = "7/4";
}
elsif ($k eq "2.0") {
  $k = 2.0;
  $k_str = "2.0";
}
elsif ($k eq "4.0") {
  $k = 4.0;
  $k_str = "4.0";
}
elsif ($k eq "Infinity") {
  $k = 10000;
  $k_str = "Infinity";
}

$k = sprintf "%.2f", $k;

if ($state eq "NONE") {
  $cnty = "no";
  $city = "no";
} 
elsif ($state eq "Alabama") {
  $cnty = "sdf/data/Alabama/co01_d00.dat";
  $city = "sdf/data/Alabama/city";
} 
elsif ($state eq "Alaska") {
  $cnty = "sdf/data/Alaska/co02_d00.dat";
  $city = "sdf/data/Alaska/city";
} 
elsif ($state eq "Arizona") {
  $cnty = "sdf/data/Arizona/co04_d00.dat";
  $city = "sdf/data/Arizona/city";
}
elsif ($state eq "Arkansas") {
  $cnty = "sdf/data/Arkansas/co05_d00.dat";
  $city = "sdf/data/Arkansas/city";
} 
elsif ($state eq "California") {
  $cnty = "sdf/data/California/co06_d00.dat";
  $city = "sdf/data/California/city";
} 
elsif ($state eq "Colorado") {
  $cnty = "sdf/data/Colorado/co08_d00.dat";
  $city = "sdf/data/Colorado/city";
} 
elsif ($state eq "Connecticut") {
  $cnty = "sdf/data/Connecticut/co09_d00.dat";
  $city = "sdf/data/Connecticut/city";
} 
elsif ($state eq "Delaware") {
  $cnty = "sdf/data/Delaware/co10_d00.dat";
  $city = "sdf/data/Delaware/city";
} 
elsif ($state eq "District of Columbia") {
  $cnty = "sdf/data/DC/co11_d00.dat";
  $city = "sdf/data/DC/city";
} 
elsif ($state eq "Florida") {
  $cnty = "sdf/data/Florida/co12_d00.dat";
  $city = "sdf/data/Florida/city";
} 
elsif ($state eq "Georgia") {
  $cnty = "sdf/data/Georgia/co13_d00.dat";
  $city = "sdf/data/Georgia/city";
} 
elsif ($state eq "Hawaii") {
  $cnty = "sdf/data/Hawaii/co15_d00.dat";
  $city = "sdf/data/Hawaii/city";
} 
elsif ($state eq "Idaho") {
  $cnty = "sdf/data/Idaho/co16_d00.dat";
  $city = "sdf/data/Idaho/city";
} 
elsif ($state eq "Illinois") {
  $cnty = "sdf/data/Illinois/co17_d00.dat";
  $city = "sdf/data/Illinois/city";
}
elsif ($state eq "Indiana") {
  $cnty = "sdf/data/Indiana/co18_d00.dat";
  $city = "sdf/data/Indiana/city";
}
elsif ($state eq "Iowa") {
  $cnty = "sdf/data/Iowa/co19_d00.dat";
  $city = "sdf/data/Iowa/city";
}
elsif ($state eq "Kansas") {
  $cnty = "sdf/data/Kansas/co20_d00.dat";
  $city = "sdf/data/Kansas/city";
}
elsif ($state eq "Kentucky") {
  $cnty = "sdf/data/Kentucky/co21_d00.dat";
  $city = "sdf/data/Kentucky/city";
}
elsif ($state eq "Louisiana") {
  $cnty = "sdf/data/Louisiana/co22_d00.dat";
  $city = "sdf/data/Louisiana/city";
}
elsif ($state eq "Maine") {
  $cnty = "sdf/data/Maine/co23_d00.dat";
  $city = "sdf/data/Maine/city";
}
elsif ($state eq "Maryland") {
  $cnty = "sdf/data/Maryland/co24_d00.dat";
  $city = "sdf/data/Maryland/city";
}
elsif ($state eq "Massachusetts") {
  $cnty = "sdf/data/Massachusetts/co25_d00.dat";
  $city = "sdf/data/Massachusetts/city";
}
elsif ($state eq "Michigan") {
  $cnty = "sdf/data/Michigan/co26_d00.dat";
  $city = "sdf/data/Michigan/city";
}
elsif ($state eq "Minnesota") {
  $cnty = "sdf/data/Minnesota/co27_d00.dat";
  $city = "sdf/data/Minnesota/city";
}
elsif ($state eq "Mississippi") {
  $cnty = "sdf/data/Mississippi/co28_d00.dat";
  $city = "sdf/data/Mississippi/city";
}
elsif ($state eq "Missouri") {
  $cnty = "sdf/data/Missouri/co29_d00.dat";
  $city = "sdf/data/Missouri/city";
}
elsif ($state eq "Montana") {
  $cnty = "sdf/data/Montana/co30_d00.dat";
  $city = "sdf/data/Montana/city";
}
elsif ($state eq "Nebraska") {
  $cnty = "sdf/data/Nebraska/co31_d00.dat";
  $city = "sdf/data/Nebraska/city";
}
elsif ($state eq "Nevada") {
  $cnty = "sdf/data/Nevada/co32_d00.dat";
  $city = "sdf/data/Nevada/city";
}
elsif ($state eq "New Hampshire") {
  $cnty = "sdf/data/NewHampshire/co33_d00.dat";
  $city = "sdf/data/NewHampshire/city";
}
elsif ($state eq "New Jersey") {
  $cnty = "sdf/data/NewJersey/co34_d00.dat";
  $city = "sdf/data/NewJersey/city";
}
elsif ($state eq "New Mexico") {
  $cnty = "sdf/data/NewMexico/co35_d00.dat";
  $city = "sdf/data/NewMexico/city";
}
elsif ($state eq "New York") {
  $cnty = "sdf/data/NewYork/co36_d00.dat";
  $city = "sdf/data/NewYork/city";
}
elsif ($state eq "North Carolina") {
  $cnty = "sdf/data/NorthCarolina/co37_d00.dat";
  $city = "sdf/data/NorthCarolina/city";
}
elsif ($state eq "North Dakota") {
  $cnty = "sdf/data/NorthDakota/co38_d00.dat";
  $city = "sdf/data/NorthDakota/city";
}
elsif ($state eq "Ohio") {
  $cnty = "sdf/data/Ohio/co39_d00.dat";
  $city = "sdf/data/Ohio/city";
}
elsif ($state eq "Oklahoma") {
  $cnty = "sdf/data/Oklahoma/co40_d00.dat";
  $city = "sdf/data/Oklahoma/city";
}
elsif ($state eq "Oregon") {
  $cnty = "sdf/data/Oregon/co41_d00.dat";
  $city = "sdf/data/Oregon/city";
}
elsif ($state eq "Pennsylvania") {
  $cnty = "sdf/data/Pennsylvania/co42_d00.dat";
  $city = "sdf/data/Pennsylvania/city";
}
elsif ($state eq "Rhode Island") {
  $cnty = "sdf/data/RhodeIsland/co44_d00.dat";
  $city = "sdf/data/RhodeIsland/city";
}
elsif ($state eq "South Carolina") {
  $cnty = "sdf/data/SouthCarolina/co45_d00.dat";
  $city = "sdf/data/SouthCarolina/city";
}
elsif ($state eq "South Dakota") {
  $cnty = "sdf/data/SouthDakota/co46_d00.dat";
  $city = "sdf/data/SouthDakota/city";
}
elsif ($state eq "Tennessee") {
  $cnty = "sdf/data/Tennessee/co47_d00.dat";
  $city = "sdf/data/Tennessee/city";
}
elsif ($state eq "Texas") {
  $cnty = "sdf/data/Texas/co48_d00.dat";
  $city = "sdf/data/Texas/city";
}
elsif ($state eq "Utah") {
  $cnty = "sdf/data/Utah/co49_d00.dat";
  $city = "sdf/data/Utah/city";
}
elsif ($state eq "Vermont") {
  $cnty = "sdf/data/Vermont/co50_d00.dat";
  $city = "sdf/data/Vermont/city";
}
elsif ($state eq "Virginia") {
  $cnty = "sdf/data/Virginia/co51_d00.dat";
  $city = "sdf/data/Virginia/city";
}
elsif ($state eq "Washington") {
  $cnty = "sdf/data/Washington/co53_d00.dat";
  $city = "sdf/data/Washington/city";
}
elsif ($state eq "West Virginia") {
  $cnty = "sdf/data/WestVirginia/co54_d00.dat";
  $city = "sdf/data/WestVirginia/city";
}
elsif ($state eq "Wisconsin") {
  $cnty = "sdf/data/Wisconsin/co55_d00.dat";
  $city = "sdf/data/Wisconsin/city";
}
elsif ($state eq "Wyoming") {
  $cnty = "sdf/data/Wyoming/co56_d00.dat";
  $city = "sdf/data/Wyoming/city";
}
elsif ($state eq "American Samoa") {
  $cnty = "sdf/data/AmericanSamoa/co60_d00.dat";
  $city = "sdf/data/AmericanSamoa/city";
}
elsif ($state eq "Guam") {
  $cnty = "sdf/data/Guam/co66_d00.dat";
  $city = "sdf/data/Guam/city";
}
elsif ($state eq "N. Mariana Islands") {
  $cnty = "sdf/data/NMarianaIslands/co69_d00.dat";
  $city = "sdf/data/NMarianaIslands/city";
}
elsif ($state eq "Puerto Rico") {
  $cnty = "sdf/data/PuertoRico/co72_d00.dat";
  $city = "sdf/data/PuertoRico/city";
}
elsif ($state eq "Virgin Islands") {
  $cnty = "sdf/data/VirginIslands/co78_d00.dat";
  $city = "sdf/data/VirginIslands/city";
}

## Coverage Area
#
$coverage =~ tr/0-9.//csd;
  
if (!$coverage || $coverage <= 0 || $coverage >= 300) {
  $coverage = 20;
  $coverage_val = "miles";
}

if ($coverage_val eq "miles") {
  $cov_mi = sprintf "%.2f", $coverage;
  $cov_km = sprintf "%.2f", $coverage * 1.609344;
}
else {
  $cov_mi = sprintf "%.2f", $coverage / 1.609344;
  $cov_km = sprintf "%.2f", $coverage;
}

# Draw me a web page
#
$b = "<font color=\"blue\">";
$p = "<font color=\"purple\">";
$e = "</font>";

print <<EOF;
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html>
<head>
<title>Line-of-Sight Path Analysis Results</title>
</head>
<body bgcolor="#D3D3D3" text="#000000" link="blue">
<center>
<h2>Line-of-Sight Path Analysis Results</h2>
</center>

<hr noshade>
<pre>
<u><b>Transmitter Site One</b></u>

               $b Latitude : $e$LAT1$b ($e$LAT1_D$b&deg; $e$LAT1_M$b' $e$LAT1_S$b") North $e
              $b Longitude : $e$LON1$b ($e$LON1_D$b&deg; $e$LON1_M$b' $e$LON1_S$b") West $e
         $b Antenna Height : $e$tx_ant_ht_m$b meters ($e$tx_ant_ht_ft$b feet) AGL $e
  
<u><b>Transmitter Site Two</b></u>

               $b Latitude : $e$LAT2$b ($e$LAT2_D$b&deg; $e$LAT2_M$b' $e$LAT2_S$b") North $e
              $b Longitude : $e$LON2$b ($e$LON2_D$b&deg; $e$LON2_M$b' $e$LON2_S$b") West $e
         $b Antenna Height : $e$tx2_ant_ht_m$b meters ($e$tx2_ant_ht_ft$b feet) AGL $e

<u><b>Transmitter Site Three</b></u>

               $b Latitude : $e$LAT3$b ($e$LAT3_D$b&deg; $e$LAT3_M$b' $e$LAT3_S$b") North $e
              $b Longitude : $e$LON3$b ($e$LON3_D$b&deg; $e$LON3_M$b' $e$LON3_S$b") West $e
         $b Antenna Height : $e$tx3_ant_ht_m$b meters ($e$tx3_ant_ht_ft$b feet) AGL $e

<u><b>Transmitter Site Four</b></u>

               $b Latitude : $e$LAT4$b ($e$LAT4_D$b&deg; $e$LAT4_M$b' $e$LAT4_S$b") North $e
              $b Longitude : $e$LON4$b ($e$LON4_D$b&deg; $e$LON4_M$b' $e$LON4_S$b") West $e
         $b Antenna Height : $e$tx4_ant_ht_m$b meters ($e$tx4_ant_ht_ft$b feet) AGL $e

          $p Receiver Antenna Height : $e$rx_ant_ht_m$p meters ($e$rx_ant_ht_ft$p feet) AGL $e
$p Effective Earth Radius (K Factor) : $e$k_str
                  $p Coverage Radius : $e$cov_km$p kilometers ($e$cov_mi$p miles) $e
EOF
&flush(STDOUT);

$tx1qth = "tx1.qth";
$tx2qth = "tx2.qth";
$tx3qth = "tx3.qth";
$tx4qth = "tx4.qth";

$topo = "topo.ppm";

$file1 = "Transmitter_One-site_report.txt";
$file2 = "Transmitter_Two-site_report.txt";
$file3 = "Transmitter_Three-site_report.txt";
$file4 = "Transmitter_Four-site_report.txt";

open F, "> $tx1qth";
  print F "Transmitter One\n";
  print F "$LAT1\n";
  print F "$LON1\n";
  print F "$tx_ant_ht_ft\n";
close F;

open F, "> $tx2qth";
  print F "Transmitter Two\n";
  print F "$LAT2\n";
  print F "$LON2\n";
  print F "$tx2_ant_ht_ft\n";
close F;

open F, "> $tx3qth";
  print F "Transmitter Three\n";
  print F "$LAT3\n";
  print F "$LON3\n";
  print F "$tx3_ant_ht_ft\n";
close F;

open F, "> $tx4qth";
  print F "Transmitter Four\n";
  print F "$LAT4\n";
  print F "$LON4\n";
  print F "$tx4_ant_ht_ft\n";
close F;

print "\n\n<b>Starting ... (will take a few minutes)\n";
&flush(STDOUT);

if ($city eq "no") {
  if (($LAT2 && $LON2) == 0 && ($LAT3 && $LON3) == 0 && ($LAT4 && $LON4) == 0 && ($LAT1 && $LON1) > 0) {
    &System($args = "/usr/local/bin/splat -t $txqth -c $rx_ant_ht_ft -R $cov_mi -m $k -o $topo -d sdf");
  }
  elsif (($LAT3 && $LON3) == 0 && ($LAT4 && $LON4) == 0 && ($LAT1 && $LON1) > 0 && ($LAT2 && $LON2) > 0) {
    &System($args = "/usr/local/bin/splat -t $txqth $tx2qth -c $rx_ant_ht_ft -R $cov_mi -m $k -o $topo -d sdf");
  }
  elsif (($LAT4 && $LON4) == 0 && ($LAT1 && $LON1) > 0 && ($LAT2 && $LON2) > 0 && ($LAT3 && $LON3) > 0) {
    &System($args = "/usr/local/bin/splat -t $txqth $tx2qth $tx3qth -c $rx_ant_ht_ft -R $cov_mi -m $k -o $topo -d sdf");
  }
  elsif (($LAT1 && $LON1) > 0 && ($LAT2 && $LON2) > 0 && ($LAT3 && $LON3) > 0 && ($LAT4 && $LON4) > 0) {
    &System($args = "/usr/local/bin/splat -t $txqth $tx2qth $tx3qth $tx4qth -c $rx_ant_ht_ft -R $cov_mi -m $k -o $topo -d sdf");
  }
  else {
    print "<b>Fix your coordinates!</b>";
    exit 1;
  }
}
else {
  if (($LAT2 && $LON2) == 0 && ($LAT3 && $LON3) == 0 && ($LAT4 && $LON4) == 0 && ($LAT1 && $LON1) > 0) {
    &System($args = "/usr/local/bin/splat -t $tx1qth -c $rx_ant_ht_ft -R $cov_mi -s $city -b $cnty -m $k -o $topo -d sdf"); 
  }
  elsif (($LAT3 && $LON3) == 0 && ($LAT4 && $LON4) == 0 && ($LAT1 && $LON1) > 0 && ($LAT2 && $LON2) > 0) {
    &System($args = "/usr/local/bin/splat -t $tx1qth $tx2qth -c $rx_ant_ht_ft -R $cov_mi -s $city -b $cnty -m $k -o $topo -d sdf");
  }
  elsif (($LAT4 && $LON4) == 0 && ($LAT1 && $LON1) > 0 && ($LAT2 && $LON2) > 0 && ($LAT3 && $LON3) > 0) { 
    &System($args = "/usr/local/bin/splat -t $tx1qth $tx2qth $tx3qth -c $rx_ant_ht_ft -R $cov_mi -s $city -b $cnty -m $k -o $topo -d sdf");
  }
  elsif (($LAT1 && $LON1) > 0 && ($LAT2 && $LON2) > 0 && ($LAT3 && $LON3) > 0 && ($LAT4 && $LON4) > 0) {
    &System($args = "/usr/local/bin/splat -t $tx1qth $tx2qth $tx3qth $tx4qth -c $rx_ant_ht_ft -R $cov_mi -s $city -b $cnty -m $k -o $topo -d sdf");
  }
  else {
    print "<b>Fix your coordinates!</b>";
    exit 1;
  }
}

print "</b>\n";
&flush(STDOUT);

if (-f $file1) {
  open F1, "$file1";
    while (<F1>) {
      if (/^GND/) {
        ($a, $tx1_elv_ft) = split ':';
      }
      if (/^HAA/) {
        ($a, $haat1) = split ':';
      }
      if (/^  0/) {
        ($a, $A1) = split ':';
      }
      if (/^ 45/) {
        ($a, $B1) = split ':';
      } 
      if (/^ 90/) {
        ($a, $C1) = split ':';
      }
      if (/^135/) {
        ($a, $D1) = split ':';
      }
      if (/^180/) {
        ($a, $E1) = split ':';
      } 
      if (/^225/) {
        ($a, $F1) = split ':';
      } 
      if (/^270/) {
        ($a, $G1) = split ':';
      }
      if (/^315/) {
        ($a, $H1) = split ':';
      }
    }
  close F1;
print "\n\n<u><b>Transmitter Site One</b></u>\n\n";
printf "               %s Ground Elevation : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$tx1_elv_ft * 0.3048,$p,$e,$tx1_elv_ft,$p,$e;
&flush(STDOUT);
printf "   %s Height Above Average Terrain : %s%.1f%s meters (%s%.1f%s feet) %s\n",$p,$e,$haat1 * 0.3048,$p,$e,$haat1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at   0&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$A1 * 0.3048,$p,$e,$A1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  45&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$B1 * 0.3048,$p,$e,$B1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  90&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$C1 * 0.3048,$p,$e,$C1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 135&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$D1 * 0.3048,$p,$e,$D1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 180&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$E1 * 0.3048,$p,$e,$E1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 225&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$F1 * 0.3048,$p,$e,$F1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 270&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$G1 * 0.3048,$p,$e,$G1,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 315&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$H1 * 0.3048,$p,$e,$H1,$p,$e;
&flush(STDOUT);
}

if (-f $file2) {
  open F2, "$file2";
    while (<F2>) {
      if (/^GND/) {
        ($a, $tx2_elv_ft) = split ':';
      } 
      if (/^HAA/) {
        ($a, $haat2) = split ':';
      } 
      if (/^  0/) {
        ($a, $A2) = split ':';
      } 
      if (/^ 45/) {
        ($a, $B2) = split ':';
      } 
      if (/^ 90/) {
        ($a, $C2) = split ':';
      } 
      if (/^135/) {
        ($a, $D2) = split ':';
      } 
      if (/^180/) {
        ($a, $E2) = split ':';
      } 
      if (/^225/) {
        ($a, $F2) = split ':';
      } 
      if (/^270/) {
        ($a, $G2) = split ':';
      } 
      if (/^315/) {
        ($a, $H2) = split ':';
      } 
    } 
  close F2;
print "\n\n<u><b>Transmitter Site Two</b></u>\n\n";
printf "               %s Ground Elevation : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$tx2_elv_ft * 0.3048,$p,$e,$tx2_elv_ft,$p,$e;
&flush(STDOUT);
printf "   %s Height Above Average Terrain : %s%.1f%s meters (%s%.1f%s feet) %s\n",$p,$e,$haat2 * 0.3048,$p,$e,$haat2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at   0&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$A2 * 0.3048,$p,$e,$A2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  45&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$B2 * 0.3048,$p,$e,$B2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  90&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$C2 * 0.3048,$p,$e,$C2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 135&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$D2 * 0.3048,$p,$e,$D2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 180&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$E2 * 0.3048,$p,$e,$E2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 225&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$F2 * 0.3048,$p,$e,$F2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 270&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$G2 * 0.3048,$p,$e,$G2,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 315&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$H2 * 0.3048,$p,$e,$H2,$p,$e;
&flush(STDOUT);
} 

if (-f $file3) {
  open F3, "$file3";
    while (<F3>) {
      if (/^GND/) {
        ($a, $tx3_elv_ft) = split ':';
      }
      if (/^HAA/) {
        ($a, $haat3) = split ':';
      }
      if (/^  0/) {
        ($a, $A3) = split ':';
      }
      if (/^ 45/) {
        ($a, $B3) = split ':';
      }
      if (/^ 90/) {
        ($a, $C3) = split ':';
      }
      if (/^135/) {
        ($a, $D3) = split ':';
      }
      if (/^180/) {
        ($a, $E3) = split ':';
      }
      if (/^225/) {
        ($a, $F3) = split ':';
      }
      if (/^270/) {
        ($a, $G3) = split ':';
      }
      if (/^315/) {
        ($a, $H3) = split ':';
      }
    }
  close F3;
print "\n\n<u><b>Transmitter Site Three</b></u>\n\n";
printf "               %s Ground Elevation : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$tx3_elv_ft * 0.3048,$p,$e,$tx3_elv_ft,$p,$e;
&flush(STDOUT);
printf "   %s Height Above Average Terrain : %s%.1f%s meters (%s%.1f%s feet) %s\n",$p,$e,$haat3 * 0.3048,$p,$e,$haat3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at   0&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$A3 * 0.3048,$p,$e,$A3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  45&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$B3 * 0.3048,$p,$e,$B3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  90&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$C3 * 0.3048,$p,$e,$C3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 135&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$D3 * 0.3048,$p,$e,$D3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 180&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$E3 * 0.3048,$p,$e,$E3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 225&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$F3 * 0.3048,$p,$e,$F3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 270&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$G3 * 0.3048,$p,$e,$G3,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 315&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$H3 * 0.3048,$p,$e,$H3,$p,$e;
&flush(STDOUT);
}

if (-f $file4) {
  open F4, "$file4";
    while (<F4>) {
      if (/^GND/) {
        ($a, $tx4_elv_ft) = split ':';
      }
      if (/^HAA/) {
        ($a, $haat4) = split ':';
      }
      if (/^  0/) { 
        ($a, $A4) = split ':';
      }
      if (/^ 45/) { 
        ($a, $B4) = split ':';
      }
      if (/^ 90/) { 
        ($a, $C4) = split ':';
      }
      if (/^135/) { 
        ($a, $D4) = split ':';
      }
      if (/^180/) { 
        ($a, $E4) = split ':';
      }
      if (/^225/) { 
        ($a, $F4) = split ':';
      }
      if (/^270/) { 
        ($a, $G4) = split ':';
      }
      if (/^315/) { 
        ($a, $H4) = split ':';
      }
    }
  close F4;
print "\n\n<u><b>Transmitter Site Four</b></u>\n\n";
printf "               %s Ground Elevation : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$tx4_elv_ft * 0.3048,$p,$e,$tx4_elv_ft,$p,$e;
&flush(STDOUT);
printf "   %s Height Above Average Terrain : %s%.1f%s meters (%s%.1f%s feet) %s\n",$p,$e,$haat4 * 0.3048,$p,$e,$haat4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at   0&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$A4 * 0.3048,$p,$e,$A4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  45&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$B4 * 0.3048,$p,$e,$B4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at  90&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$C4 * 0.3048,$p,$e,$C4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 135&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$D4 * 0.3048,$p,$e,$D4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 180&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$E4 * 0.3048,$p,$e,$E4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 225&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$F4 * 0.3048,$p,$e,$F4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 270&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$G4 * 0.3048,$p,$e,$G4,$p,$e;
&flush(STDOUT);
printf "%s Average Terrain at 315&deg; Azimuth : %s%.1f%s meters (%s%.1f%s feet) AMSL %s\n",$p,$e,$H4 * 0.3048,$p,$e,$H4,$p,$e;
&flush(STDOUT);
}

if ($quality eq "Low / Fast") {
  print "\n\n<b>Generating Low Quality JPEG Image ..</b>";
  &flush(STDOUT);

  &System($args = "/usr/bin/pnmtojpeg --quality=10 $topo > GBPPR_LOS.jpg");

  print "\n\n<b>Map Coverage Colors</b>\n\n";


  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#00FF00\" align=center><b>Site 1</b></td>\n";
  print "<td colspan=10 bgcolor=\"#00FFFF\" align=center><b>Site 2</b></td>\n";
  print "<td colspan=10 bgcolor=\"#9370DB\" align=center><b>Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#FF8247\" align=center><b>Site 4</b></td></tr></table>\n";

  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#FFFF00\" align=center><b>Site 1 + Site 2</b></td>\n";
  print "<td colspan=10 bgcolor=\"#FFC0CB\" align=center><b>Site 1 + Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#ADFF2F\" align=center><b>Site 1 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#FFA500\" align=center><b>Site 2 + Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#C1FFC1\" align=center><b>Site 2 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#00CED1\" align=center><b>Site 3 + Site 4</b></td></tr></table>\n";

  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#006400\" align=center><b>Site 1 + Site 2 + Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#FFEBCD\" align=center><b>Site 1 + Site 2 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#00FA9A\" align=center><b>Site 1 + Site 3 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#D2B48C\" align=center><b>Site 2 + Site 3 + Site 4</b></td></tr></table>\n";

  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#EEC900\" align=center><b>Site 1 + Site 2 + Site 3 + Site 4</b></td></tr></table>\n"; 
  &flush(STDOUT);


  $size = (-s "GBPPR_LOS.jpg");
  print "<p><b>Displaying $size byte JPEG Image ..</b></p>\n";
  print "<p><img src=\"tmp/$mon-$mday/$RAN/GBPPR_LOS.jpg\"></p>\n";
  print "</body>\n";
  print "</html>\n";
  &flush(STDOUT);
}
else {

  print "\n\n<b>Generating High Quality PNG Image ..</b>";
  &flush(STDOUT);
  
  &System($args = "/usr/bin/pnmtopng -compression 9 $topo > GBPPR_LOS.png");

  print "\n\n<b>Map Coverage Colors</b>\n\n";
					
  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#00FF00\" align=center><b>Site 1</b></td>\n";
  print "<td colspan=10 bgcolor=\"#00FFFF\" align=center><b>Site 2</b></td>\n";
  print "<td colspan=10 bgcolor=\"#9370DB\" align=center><b>Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#FF8247\" align=center><b>Site 4</b></td></tr></table>\n";

  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#FFFF00\" align=center><b>Site 1 + Site 2</b></td>\n";     
  print "<td colspan=10 bgcolor=\"#FFC0CB\" align=center><b>Site 1 + Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#ADFF2F\" align=center><b>Site 1 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#FFA500\" align=center><b>Site 2 + Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#C1FFC1\" align=center><b>Site 2 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#00CED1\" align=center><b>Site 3 + Site 4</b></td></tr></table>\n";

  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#006400\" align=center><b>Site 1 + Site 2 + Site 3</b></td>\n";
  print "<td colspan=10 bgcolor=\"#FFEBCD\" align=center><b>Site 1 + Site 2 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#00FA9A\" align=center><b>Site 1 + Site 3 + Site 4</b></td>\n";
  print "<td colspan=10 bgcolor=\"#D2B48C\" align=center><b>Site 2 + Site 3 + Site 4</b></td></tr></table>\n";

  print "<table border=2 cellpadding=2><tr><td colspan=10 bgcolor=\"#EEC900\" align=center><b>Site 1 + Site 2 + Site 3 + Site 4</b></td></tr></table>\n";
  &flush(STDOUT);

  $size = (-s "GBPPR_LOS.png");
  print "<p><b>Displaying $size byte PNG Image ..</b></p>\n";
  print "<p><img src=\"tmp/$mon-$mday/$RAN/GBPPR_LOS.png\"></p>\n";
  print "</body>\n";
  print "</html>\n";
  &flush(STDOUT);
}

unlink $tx1qth, $tx2qth, $tx3qth, $tx4qth, $topo, $file1, $file2, $file3, $file4, "topo.ppm", "sdf";

exit 0;
