#!/usr/bin/perl 

## --> Longley-Rice Path Loss Analysis, longley.main.cgi
## --> Green Bay Professional Packet Radio, www.gbppr.org

## This file Copyright 2004 <contact@gbppr.org> under the GPL
## NO WARRANTY. Please send bug reports / patches / reports.

# Setup
#
select STDOUT;
$| = 1;

# User stuff
#
my $pic = "pics/lon.jpg";
my $form = "./longley.cgi";

# Print MIME
#
print "Content-type:text/html\n\n";

# Draw me a web page
#
print <<EOF;
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html>
<head>
<title>Longley-Rice Path Loss Analysis</title>
</head>
<body bgcolor="#D3D3D3" text="#000000" link="blue">
<center>
<font face="Verdana, Arial, Helvetica"><h2>Longley-Rice Path Loss Analysis</h2></font>
<p>A service of <a href="http://www.gbppr.org">Green Bay Professional Packet Radio</a></p>
</center>

<hr noshade>
<center><img src="$pic" alt="[lon]"></center>
<hr noshade>

<form action="$form" method="post">

<br>
<center>
<table border="2" cellpadding="2">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Transmitter Site</b></font></td>
</tr>
</table>
</center>
<br>

<table border="0">
<tr>
<td align="right"><b>Latitude&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="LAT1_D" size="2" value="44">&nbsp;&deg;&nbsp;
<input type="text" name="LAT1_M" size="2" value="31">&nbsp;'&nbsp;
<input type="text" name="LAT1_S" size="3" value="47">&nbsp;&quot;&nbsp;&nbsp;North</td>
</tr>

<tr>
<td align="right"><b>Longitude&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="LON1_D" size="2" value="88">&nbsp;&deg;&nbsp;
<input type="text" name="LON1_M" size="2" value="02">&nbsp;'&nbsp;
<input type="text" name="LON1_S" size="3" value="26">&nbsp;&quot;&nbsp;&nbsp;West</td>
</tr>

<tr>
<td align="right"><b>Antenna Height (AGL)&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="tx_ant_ht" size="5" value="30">
<select name="tx_ant_ht_val">
<option selected>meters</option>
<option>feet</option>
</select>&nbsp;&nbsp;Center-of-Radiation</td>
</tr>

<tr>
<td align="right"><b>Highest Transmitted Frequency&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="frq" size="5" value="2467">
<select name="frq_val">
<option selected>MHz</option>
<option>GHz</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Antenna Polarization&nbsp;&nbsp;</b></td>
<td align="left"><select name="polar">
<option>Horizontal</option>
<option selected>Vertical</option>
</select></td>
</tr>
</table>

<br>
<center>
<table border="2" cellpadding="2">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Receiver Information</b></font></td>
</tr>
</table>
</center>
<br>

<table border="0">
<tr>
<td align="right"><b>Receiver Antenna Height (AGL)&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="rx_ant_ht" size="5" value="1.5">
<select name="rx_ant_ht_val">
<option selected>meters</option>
<option>feet</option>
</select>&nbsp;&nbsp;Center-of-Radiation</td>
</tr>
</table>

<br>
<center>
<table border="2" cellpadding="2">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Longley-Rice Calculation Parameters</b></font></td>
</tr>
</table>
</center>
<br>

<table border="0">
<tr>
<td align="right"><b><a href="pics/con.html">Ground Dielectric Constant</a>&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="diecon" size="5" value="15">&nbsp;&nbsp;(Relative Permittivity)</td>
</tr>

<tr>
<td align="right"><b><a href="pics/earcon.jpg">Ground Conductivity</a>&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="earcon" size="7" value="0.005">&nbsp;&nbsp;Siemens per meter</td>
</tr>

<tr>
<td align="right"><b>Select the Effective Earth Radius, K Factor&nbsp;&nbsp;</b></td>
<td align="left"><select name="k">
<option>7/6</option>
<option selected>4/3</option>
<option>5/3</option>
<option>7/4</option>
<option>2.0</option>
<option>4.0</option>
<option>Infinity</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Select the Climate Type&nbsp;&nbsp;</b></td>
<td align="left"><select name="climate">
<option>Equatorial</option>
<option>Continental Subtropical</option>
<option>Maritime Subtropical</option>
<option>Desert</option>
<option selected>Continental Temperate</option>
<option>Maritime Temperate, Overland</option>
<option>Maritime Temperate, Oversea</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Confidence / Situation Variability&nbsp;&nbsp;</b></td>
<td align="left"><select name="sit"> 
<option>3 %</option>
<option>10 %</option>
<option>20 %</option>
<option>30 %</option>
<option>40 %</option>
<option selected>50 %</option>
<option>60 %</option>
<option>70 %</option>
<option>80 %</option>
<option>90 %</option>
<option>97 %</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Reliability / Time Variability&nbsp;&nbsp;</b></td>
<td align="left"><select name="time">
<option>3 %</option>
<option>10 %</option>
<option>20 %</option>
<option>30 %</option>
<option>40 %</option>
<option>50 %</option>
<option>60 %</option>
<option>70 %</option>
<option>80 %</option>
<option selected>90 %</option>
<option>97 %</option>
</select></td>
</tr>
</table>

<br>
<center>
<table border="2" cellpadding="2">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Miscellaneous</b></font></td>
</tr>
</table>
</center>
<br>

<table border="0">
<tr>
<td align="right"><b>Select State for Above Site&nbsp;&nbsp;</b></td>
<td align="left"><select name="state">
<option>NONE</option>
<option>Alabama</option>
<option>Alaska</option>
<option>Arizona</option>
<option>Arkansas</option>
<option>California</option>
<option>Colorado</option>
<option>Connecticut</option>
<option>Delaware</option>
<option>District of Columbia</option>
<option>Florida</option>
<option>Georgia</option>
<option>Hawaii</option>
<option>Idaho</option>
<option>Illinois</option>
<option>Indiana</option>
<option>Iowa</option>
<option>Kansas</option>
<option>Kentucky</option>
<option>Louisiana</option>
<option>Maine</option>
<option>Maryland</option>
<option>Massachusetts</option>
<option>Michigan</option>
<option>Minnesota</option>
<option>Mississippi</option>
<option>Missouri</option>
<option>Montana</option>
<option>Nebraska</option>
<option>Nevada</option>
<option>New Hampshire</option>
<option>New Jersey</option>
<option>New Mexico</option>
<option>New York</option>
<option>North Carolina</option>
<option>North Dakota</option>
<option>Ohio</option>
<option>Oklahoma</option>
<option>Oregon</option>
<option>Pennsylvania</option>
<option>Rhode Island</option>
<option>South Carolina</option>
<option>South Dakota</option>
<option>Tennessee</option>
<option>Texas</option>
<option>Utah</option>
<option>Vermont</option>
<option>Virginia</option>
<option>Washington</option>
<option>West Virginia</option>
<option selected>Wisconsin</option>
<option>Wyoming</option>
<option>American Samoa</option>
<option>Guam</option>
<option>N. Mariana Islands</option>
<option>Puerto Rico</option>
<option>Virgin Islands</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Coverage Radius&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="coverage" size="5" value="30">
<select name="coverage_val">
<option selected>kilometers</option>
<option>miles</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Maximum Path Loss&nbsp;&nbsp;</b></td>
<td align="left"><select name="maxdb">
<option>80</option>
<option>90</option>
<option>100</option>
<option>110</option>
<option>120</option>
<option>130</option>
<option>140</option>
<option>150</option>
<option>160</option>
<option>170</option>
<option>180</option>
<option>190</option>
<option>200</option>
<option>210</option>
<option>220</option>
<option selected>230</option>
</select>&nbsp;&nbsp;dB</td>
</tr>

<tr>
<td align="right"><b>Select Output Image Quality&nbsp;&nbsp;</b></td>
<td align="left"><select name="quality">
<option selected>Low / Fast</option>
<option>High / Slow</option>
</select></td>
</tr>
</table>

<hr noshade>
<center>
<table>
<tr>
<td><input type="submit" value="Submit"></td>
<td><input type="reset" value="Clear"></td>
</tr>
</table>
</center>
</form>

<hr noshade size="5">
</font>
<blockquote>
<ul>
<li>Don't enter the minus (-) sign on longitude data.</li>

<p></p>

<li>K Factor of <tt>1.0</tt> is the true Earth radius, K Factor of <tt>Infinity</tt> is a flat Earth.</li>

<p></p>

<li>Reception is usually described as LR(50/90).&nbsp;&nbsp;This is a 50% confidence that reception will be received 90% of the time.</li>

<p></p>

<li>Press <tt>Submit</tt> to see an example.</li>

<p></p>

<li>It takes about 10 minutes for the plotting to complete.&nbsp;&nbsp;Decrease Coverage Radius for faster plotting.</li>

<p></p>

<li>Don't hit <tt>Stop</tt> half way through the process.</li>

<p></p>

<li><a href="coords.txt">Available</a> elevation coordinates.</li>
</ul>
</blockquote>

</body>
</html>
EOF
