#!/usr/bin/perl 

## --> Microwave Radio Path Analysis, path.main.cgi
## --> Green Bay Professional Packet Radio, www.gbppr.org

## This file Copyright 2003 <contact@gbppr.org> under the GPL
## NO WARRANTY. Please send bug reports / patches / reports.

## Program Setup
#
select STDOUT;
$| = 1;

## User Setup
#
my $pic = "pics/path.png";
my $form = "./path.cgi";
my $banner = "A service of <a href=\"http://www.gbppr.org\">Green Bay Professional Packet Radio</a>";

## Print MIME
#
print "Content-type:text/html\n\n";

## Draw me a web page
#
print <<EOF;
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html>
<head>
<title>Microwave Radio Path Analysis</title>
</head>
<body bgcolor="#D3D3D3" text="#000000" link="blue">
<center>
<font face="Verdana, Arial, Helvetica">
<h2>Microwave Radio Path Analysis</h2>
<p>$banner</p>
</font>
</center>

<hr noshade>
<center><img src="$pic" alt="[path]"></center>
<hr noshade>

<center>
<br>
<table border="2" cellpadding="6">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Location Information</b></font></td>
</tr>
</table>
<br>
</center>

<form action="$form" method="post">
<table border="0">
<tr>
<td align="right"><b>Transmitter Site Name&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="tx_name" size="30" value="Tx"></td>
</tr>

<tr>
<td align="right"><b>Transmitter Site Latitude&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="LAT1_D" size="2" value="44">&nbsp;&deg;&nbsp;
<input type="text" name="LAT1_M" size="2" value="31">&nbsp;'&nbsp;
<input type="text" name="LAT1_S" size="3" value="47">&nbsp;&quot;&nbsp;&nbsp;North</td>
</tr>

<tr>
<td align="right"><b>Transmitter Site Longitude&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="LON1_D" size="2" value="88">&nbsp;&deg;&nbsp;
<input type="text" name="LON1_M" size="2" value="02">&nbsp;'&nbsp;
<input type="text" name="LON1_S" size="3" value="26">&nbsp;&quot;&nbsp;&nbsp;West</td>
</tr>

<tr>
<td align="right"><b>Receiver Site Name&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="rx_name" size="30" value="Rx"></td>
</tr>

<tr>
<td align="right"><b>Receiver Site Latitude&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="LAT2_D" size="2" value="44">&nbsp;&deg;&nbsp;
<input type="text" name="LAT2_M" size="2" value="30">&nbsp;'&nbsp;
<input type="text" name="LAT2_S" size="3" value="04">&nbsp;&quot;&nbsp;&nbsp;North</td>
</tr>

<tr>
<td align="right"><b>Receiver Site Longitude&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="LON2_D" size="2" value="87">&nbsp;&deg;&nbsp;
<input type="text" name="LON2_M" size="2" value="56">&nbsp;'&nbsp;
<input type="text" name="LON2_S" size="3" value="51">&nbsp;&quot;&nbsp;&nbsp;West</td>
</tr>
</table>

<center>
<br>
<table border="2" cellpadding="6">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Antenna Information</b></font></td>
</tr>
</table>
<br>
</center>

<table border="0">
<tr>
<td align="right"><b>Transmitter Antenna Height (AGL)&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="tx_ant_ht" size="5" value="14">
<select name="tx_ant_ht_val">
<option selected>meters</option>
<option>feet</option>
</select>&nbsp;&nbsp;Center-of-Radiation</td>
</tr>

<tr>
<td align="right"><b>Receiver Antenna Height (AGL)&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="rx_ant_ht" size="5" value="19">
<select name="rx_ant_ht_val">
<option selected>meters</option>
<option>feet</option>
</select>&nbsp;&nbsp;Center-of-Radiation</td>
</tr>

<tr>
<td align="right"><b>Highest Transmitted Frequency&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="frq" size="5" value="2467">
<select name="frq_val">
<option selected>MHz</option>
<option>GHz</option>
</select></td>
</tr>
</table>

<center>
<br>
<table border="2" cellpadding="6">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Environmental Information</b></font></td>
</tr>
</table>
<br>
</center>

<table border="0">
<tr>
<td align="right"><b>Select the Effective Earth Radius, K Factor&nbsp;&nbsp;</b></td>
<td align="left"><select name="k">
<option>5/12</option>
<option>1/2</option>
<option>2/3</option>
<option>1.0</option>
<option>7/6</option>
<option selected>4/3</option>
<option>5/3</option>
<option>7/4</option>
<option>2.0</option>
<option>4.0</option>
<option>Infinity</option>
</select></td>
</tr>

<tr>
<td align="right"><b>N <sup>th</sup> Fresnel Zone to Calculate&nbsp;&nbsp;</b></td>
<td align="left"><select name="nth">
<option selected>None</option>
<option>0.1</option>
<option>0.2</option>
<option>0.3</option>
<option>0.4</option>
<option>0.5</option>
<option>0.7</option>
<option>0.8</option>
<option>0.9</option>
<option>1.0</option>
<option>2.0</option>
<option>3.0</option>
<option>4.0</option>
<option>5.0</option>
<option>6.0</option>
<option>7.0</option>
<option>8.0</option>
<option>9.0</option>
<option>10.0</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Select the <a href="pics/gbppr-usa-crane.jpg">Rain Region</a>&nbsp;&nbsp;</b></td>
<td align="left"><select name="rain">
<option>B : Polar Taiga (Moderate)</option>
<option>C : Temperate Maritime</option>
<option selected>D1 : Temperate Continental (Dry)</option>
<option>D2 : Temperate Continental (Mid)</option>
<option>D3 : Temperate Continental (Wet)</option>
<option>E : Sub Tropical Wet</option>
<option>F : Sub Tropical Arid</option>
</select></td>
</tr>
</table>

<center>
<br>
<table border="2" cellpadding="6">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Longley-Rice Path Calculation Parameters - Optional</b></font></td>
</tr>
</table>
<br>
</center>

<table border="0">
<tr>
<td align="right"><b><a href="pics/con.html">Ground Dielectric Constant</a>&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="diecon" size="5" value="15">&nbsp;&nbsp;(Relative Permittivity)</td>
</tr>

<tr>
<td align="right"><b><a href="pics/earcon.jpg">Ground Conductivity</a>&nbsp;&nbsp;</b></td>
<td align="left"><input type="text" name="earcon" size="7" value="0.005">&nbsp;&nbsp;Siemens per meter</td>
</tr>

<tr>
<td align="right"><b>Select the Climate Type&nbsp;&nbsp;</b></td>
<td align="left"><select name="climate">
<option>Equatorial</option>
<option>Continental Subtropical</option>
<option>Maritime Subtropical</option>
<option>Desert</option>
<option selected>Continental Temperate</option>
<option>Maritime Temperate, Overland</option>
<option>Maritime Temperate, Oversea</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Antenna Polarization&nbsp;&nbsp;</b></td>
<td align="left"><select name="polar">
<option>Horizontal</option>
<option selected>Vertical</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Confidence / Situation Variability&nbsp;&nbsp;</b></td>
<td align="left"><select name="sit"> 
<option>3 %</option>
<option>10 %</option>
<option>20 %</option>
<option>30 %</option>
<option>40 %</option>
<option selected>50 %</option>
<option>60 %</option>
<option>70 %</option>
<option>80 %</option>
<option>90 %</option>
<option>97 %</option>
</select></td>
</tr>

<tr>
<td align="right"><b>Reliability / Time Variability&nbsp;&nbsp;</b></td>
<td align="left"><select name="time">
<option>3 %</option>
<option>10 %</option>
<option>20 %</option>
<option>30 %</option>
<option>40 %</option>
<option>50 %</option>
<option>60 %</option>
<option>70 %</option>
<option>80 %</option>
<option selected>90 %</option>
<option>97 %</option>
</select></td>
</tr>



</table>



<center>
<br>
<table border="2" cellpadding="6">
<tr>
<td colspan="10" bgcolor="yellow" align="center"><font size="4"><b>Path Obstructions - Optional</b></font></td>
</tr>
</table>
<br>
</center>

<table border="2" cellpadding="6">
<tr>
<th>Obstruction Distance From Tx<br>(km)</th>
<th>Obstruction Height<br>(meters)</th>
<th>Obstruction Type</th>
</tr>

<tr>
<td>&nbsp;1.&nbsp;&nbsp;<input type="text" name="EE_DIS" size="4" value=""></td>
<td><input type="text" name="EE_HT" size="5" value=""></td>
<td align="left"><select name="EE_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;2.&nbsp;&nbsp;<input type="text" name="FF_DIS" size="4" value=""></td>
<td><input type="text" name="FF_HT" size="5" value=""></td>
<td align="left"><select name="FF_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;3.&nbsp;&nbsp;<input type="text" name="GG_DIS" size="4" value=""></td>
<td><input type="text" name="GG_HT" size="5" value=""></td>
<td align="left"><select name="GG_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;4.&nbsp;&nbsp;<input type="text" name="HH_DIS" size="4" value=""></td>
<td><input type="text" name="HH_HT" size="5" value=""></td>
<td align="left"><select name="HH_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;5.&nbsp;&nbsp;<input type="text" name="II_DIS" size="4" value=""></td>
<td><input type="text" name="II_HT" size="5" value=""></td>
<td align="left"><select name="II_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;6.&nbsp;&nbsp;<input type="text" name="JJ_DIS" size="4" value=""></td>
<td><input type="text" name="JJ_HT" size="5" value=""></td>
<td align="left"><select name="JJ_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;7.&nbsp;&nbsp;<input type="text" name="KK_DIS" size="4" value=""></td>
<td><input type="text" name="KK_HT" size="5" value=""></td>
<td align="left"><select name="KK_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;8.&nbsp;&nbsp;<input type="text" name="LL_DIS" size="4" value=""></td>
<td><input type="text" name="LL_HT" size="5" value=""></td>
<td align="left"><select name="LL_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>&nbsp;9.&nbsp;&nbsp;<input type="text" name="MM_DIS" size="4" value=""></td>
<td><input type="text" name="MM_HT" size="5" value=""></td>
<td align="left"><select name="MM_TYPE">
<option selected>Tree</option>
<option>Building</option>
</select></td>
</tr>

<tr>
<td>10.&nbsp;&nbsp;<input type="text" name="NN_DIS" size="4" value=""></td>
<td><input type="text" name="NN_HT" size="5" value=""></td>
<td align="left"><select name="NN_TYPE">
<option selected>Tree</option>
<option>Building</option>
<option>Monster</option>
</select></td>
</tr>
</table>
<hr noshade>

<br>
<br>
<br>

<center>
<table>
<tr>
<td><input type="submit" value="Submit"></td>
<td></td>
<td><input type="reset" value="Clear"></td>
</tr>
</table>
</center>
</form>

<br>
<br>
<br>

<p><b><u>Notes</u></b></p>

<blockquote>

<ul>
<li>Uses <a href="http://www2.jpl.nasa.gov/srtm">Shuttle Radar Topography Mission, Version 2</a> elevation data for terrain generation.</li>

<li>Don't enter the minus (-) sign on longitude data.</li>

<li>K Factor of <tt>1.0</tt> is the true Earth radius, K Factor of <tt>Infinity</tt> is a flat Earth.</li>

<li>Reception is usually described as LR(50/90).&nbsp;&nbsp;This is a 50% confidence that reception will be received 90% of the time.</li>

<li>Press <tt>Submit</tt> to see an example.</li>

<li>It takes about 90 seconds for the plotting to complete.</li>

<li><a href="coords.txt">Available</a> elevation coordinates.</li>
</ul>
</blockquote>

</body>
</html>
EOF
